library(tidyverse)
source("functions/calculate_losses.R")
source("functions/all_losses.R")
source("functions/matching_library.R")
source("functions/reading_library_spectra.R")
source("functions/similarity_nominal.R")


data_path <- "C:/Users/annel/OneDrive - Kruvelab/Kruvelab/Teaching/Data Analysis/Labs/3. Similairy based learnign and clustering/library"
library <- reading_library_spectra(data_path)
library <- library %>%
  select(-tentative_formula, -formula_count, -mass, -error_ppm)

#let us try to find kernels
#two similarity criteria
#losses
#nominal matches

all_losses_for_library <- all_losses(library)
all_losses_for_library <- all_losses_for_library %>%
  group_by(loss) %>%
  mutate(count = n()) %>%
  ungroup() %>%
  filter(count > 2) %>%
  rename(loss_mz = loss)

all_nominal_masses <- library %>%
  select(Compound, m_z) %>%
  mutate(m_z = round(m_z, digits = 2)) %>%
  group_by(m_z) %>%
  mutate(count = n()) %>%
  ungroup() %>%
  filter(count > 2) %>%
  rename(nominal_mz = m_z)

all_losses_for_library_matches <- all_losses_for_library %>%
  select(-count)  %>%
  rename(Compound_similar = Compound) %>%
  left_join(all_losses_for_library %>% select(-count)) %>%
  filter(Compound != Compound_similar)

all_nominal_masses_matches <- all_nominal_masses %>%
  select(-count)  %>%
  rename(Compound_similar = Compound) %>%
  left_join(all_nominal_masses %>% select(-count)) %>%
  filter(Compound != Compound_similar)

similarity_summary <- all_losses_for_library_matches %>%
  bind_rows(all_nominal_masses_matches) %>%
  group_by(Compound_similar, Compound) %>%
  summarize(count = n()) %>%
  ungroup()

nodes <- library %>% select(Compound) %>% distinct()
edges <- similarity_summary %>% 
  left_join(nodes)
library(igraph)

routes_igraph <- graph_from_data_frame(d = edges, vertices = nodes, directed = TRUE)
plot(routes_igraph, edge.arrow.size = 0.2)
