calculate_losses <- function(spectrum) {
  spectrum_copy <- spectrum %>%
    rename(m_z_copy = m_z) %>%
    select(m_z_copy) 
  losses <- spectrum_copy %>%
    left_join(spectrum, by = character()) %>%
    mutate(loss = abs(m_z_copy - m_z)) %>%
    mutate(loss = round(loss, digits = 2)) %>%
    filter(loss != 0 & loss > 12) %>%
    select(loss) %>%
    unique()
  return(losses)
}