library(janitor)

reading_library_spectra <- function(data_path) {
  files <- dir(data_path, pattern = "*.txt") # get file names
  setwd(data_path)
  
  library <- tibble()
  for (filename in files) {
    name_output <- paste("fingerprint_", filename, ".csv", col="", sep="")
    file <- read_delim(filename,
                       delim = " ",
                       col_names = TRUE) %>%
      clean_names()
    
    file <- file %>%
      mutate(Compound = str_remove(filename, ".txt"))
    
    library <- library %>%
      bind_rows(file)
  }
  return(library)
}

